#include "StdAfx.h"
#include "UIChatElement.h"
#include "PlainUrl.h"
#include "ftlbase.h"
#include <gdiplus.h>
#include "UserImageActor.h"
#include "ChatMainView.h"
#include "ChatDlg.h"


#define DEF_CHAT_MSG_BUBBLE_USERNAME_TOP_Y		(4)

#define DEF_CHAT_MSG_BUBBLE_MARGIN_LEFT_X		(19)
#define DEF_CHAT_MSG_BUBBLE_MARGIN_RIGHT_X		(14)
#define DEF_CHAT_MSG_BUBBLE_MARGIN_TOP_Y		(10)
#define DEF_CHAT_MSG_BUBBLE_MARGIN_BOTTOM_Y		(10)
#define DEF_CHAT_MSG_BUBBLE_DIAMETER		(26)


#define DEF_CHAT_MSG_BUBBLE_MIN_Y			(16)
#define DEF_CHAT_MSG_BUBBLE_MIN_X			(40)

#define  PLAIN_MESSAGE_FONT_HEIGHT		(16)
#define  PLAIN_MESSAGE_POS_LEFT_PAD		(10)
#define  PLAIN_ITEM_POS_RIGHT_PAD			(12)
#define  PLAIN_MESSAGE_LINE_SPACING		(3)

#define	 PLAIN_MESSAGE_COLOR    (Color(255, 0, 0, 0))


UIChatElement::UIChatElement( CChatItem* pChatItem, IUIElementResouce* pResouce) : UIElement(pChatItem, pResouce)
{
	m_rtUserMessage.SetRectEmpty();
	m_rcSendCount.SetRectEmpty();
	m_szUserMessage.cx = 0;
	m_szUserMessage.cy = 0;	
	m_nSingleRowWith = 0;
}

UIChatElement::~UIChatElement( void )
{

}

BOOL UIChatElement::Draw( Graphics *graph )
{
	CRect rc=m_rcItem;
	CPoint ptZero(0,0);
	CPoint ptOffset = ptZero - m_pResouce->GetOffSetPoint();
	rc.OffsetRect(ptOffset);
	CRect rcToDraw = m_pResouce->GetViewRect();

	 if (rc.bottom < rcToDraw.top || rc.top > rcToDraw.bottom)
	 {
		 return FALSE;
	 }
	if (CHAT_BUBBLE == m_pResouce->GetChatDisplayType())
	{
		_DrawBubbleChat(graph);
	}
	else
	{
		//if (m_dwFlags & DEF_CHAT_MSG_USERNAME)
		//{
			DrawUserName(graph);
			DrawUserImage(graph);
		//}
		CRect rc = m_pResouce->GetViewRect();

		DrawTime(graph);
		_DrawUserMessage(graph, rc);
/*		_DrawReSendStatus(graph, rc);*/
	}

	if (m_pChatMainView->GetChatModel()->GetMyID().CompareNoCase(m_pChatItem->GetChatItemInfo()->strUserID) == 0 )
	{
		if (m_pChatItem->GetMsgStatus() != sInvalid && m_pChatItem->GetMsgStatus() != CMS_INVALID)
		{
			if (m_pChatItem->IsFailedMsg() && m_rcReSendImg.IsRectEmpty() != TRUE)
			{
				//CPoint ptZero(0, 0);
				//CPoint ptOffset = ptZero - m_pResouce->GetOffSetPoint();

				CRect rcReSend = m_rcReSendImg;
				rcReSend.OffsetRect(ptOffset);
				DrawRetryStatus(graph,rcReSend);
			}
		}
	}


	return TRUE;
}



CSize UIChatElement::CalcSize( const CPoint& ptPos, DWORD dwFlags )
{
	_Clear();
	m_dwFlags = dwFlags;
	CSize sz(0, 0);
	if (CHAT_BUBBLE == m_pResouce->GetChatDisplayType())
	{
		sz = _CalcBubbleSize(ptPos, dwFlags);
	}
	else if(CHAT_PLAIN == m_pResouce->GetChatDisplayType())
	{
		sz = _CalcPlainSize(ptPos, dwFlags);
	}

	m_rcItem.SetRect(DEF_ITEM_POS_LEFT_REL_X, 0, m_pResouce->GetViewRect().Width() - DEF_ITEM_POS_RIGHT_REL_X, sz.cy);
	m_rcItem.OffsetRect(ptPos);
	return sz;
}

void UIChatElement::OnLButtonDown(UINT nFlags, CPoint point)
{
	//_SetChatSelectedItem(point, point, FALSE);
	ResetSelectRange();
	//m_pResouce->InvalidateElement(this, FALSE);
	UIElement::OnLButtonDown(nFlags, point);
}

void UIChatElement::OnLButtonDblClk( UINT nFlags, CPoint point )
{
	_SetNameSlectedItem(point, point, TRUE);
	_SetTimeSlectedItem(point, point, TRUE);
	_SetChatSelectedItem(point, point, TRUE);

	//m_pResouce->InvalidateElement(this, FALSE);
}

BOOL UIChatElement::OnMouseMove( UINT nFlags, CPoint point )
{
	BOOL bHandled = UIElement::OnMouseMove(nFlags, point);
	if(bHandled)
	{
		return bHandled;
	}
	int nDisplayType = m_pResouce->GetChatDisplayType();
	CChatMsgItem* pMsgItem = dynamic_cast<CChatMsgItem*>(m_pChatItem);
	int nCursor = CURSOR_DEFAULT;
	if(CHAT_PLAIN == nDisplayType)
	{
		if(m_rtUserMessage.PtInRect(point))
		{
			if(_IsPointInPlainSelectionRects(point))
			{
				bHandled = TRUE;
				nCursor = CURSOR_IBEAM;
			}
		}

		if(m_rcTime.PtInRect(point) || m_rcUserName.PtInRect(point))
		{
			bHandled = TRUE;
			nCursor = CURSOR_IBEAM;
		}

		
	}
	else if(CHAT_BUBBLE == nDisplayType)
	{
		if (m_rcBubble.PtInRect(point))//  m_rcItem
		{
			if (m_rtUserMessage.PtInRect(point))
			{
				bHandled = TRUE;
				nCursor = CURSOR_IBEAM;
			}
		}
	}

	if (!(MK_LBUTTON & nFlags))
	{
		if (m_rcReSendImg.PtInRect(point) && m_pChatItem->IsFailedMsg())
		{
			bHandled = TRUE;
			CChatModel *pChatModel = m_pChatMainView->GetChatModel();
			if (pChatModel->GetMyID().CompareNoCase(m_pChatItem->GetUserId()) == 0)
			{
				if (m_rcReSendImg.PtInRect(point) && m_pChatItem->IsFailedMsg() && IsEnableRetryButton())
				{
					if (!m_pChatItem->IsGroupUserChat()
						&&pChatModel->CheckSessionCreateStatus(SESSION_SUCCESS)
						&& pChatModel->GetOfflineUserCount() == 0)
					{
						nCursor = CURSOR_HAND;
					}
				}
			}
		}
		else
		{

			int nCurPos = _GetStringIndexUnderPoint(point, nDisplayType);
			if (nCurPos >= 0)
			{
				CString strUrl = pMsgItem->GetUrlString(nCurPos);
				if (!strUrl.IsEmpty())
				{
					bHandled = TRUE;
					nCursor = CURSOR_HAND;
				}
			}

		}
	}
	
	if (MK_LBUTTON == nFlags && m_pResouce->IsMouseSelection())
	{
		CChatMsgItem* pMsgItem = dynamic_cast<CChatMsgItem*>(m_pChatItem);
		ASSERT(pMsgItem);
		if (pMsgItem)
		{
			CPoint ptStart = m_pResouce->GetSelectionStartPoint();
			CPoint ptEnd = point;

			PlainNormalizePoint(ptStart, ptEnd);
			_SetNameSlectedItem(ptStart, ptEnd, FALSE);
			_SetTimeSlectedItem(ptStart, ptEnd, FALSE);
			_SetChatSelectedItem(ptStart, ptEnd, FALSE);
			//m_pResouce->InvalidateElement(this, FALSE);
		}
	}

	m_pResouce->SetCursor(nCursor);

	return bHandled;
}

CSize UIChatElement::_CalcBubbleSize(const CPoint& ptPos, DWORD dwFlags ) 
{
	//throw std::exception("The method or operation is not implemented.");
	CSize sz(0, 0);
	CPoint ptOffset = ptPos;
	if (dwFlags & DEF_CHAT_MSG_DATE)
	{
		CalcDateSize(ptOffset, sz);
		ptOffset.y += sz.cy;
	}

	BOOL bUserName = FALSE;
	if ((dwFlags & DEF_CHAT_MSG_USERNAME) && !(dwFlags & DEF_CHAT_MSG_ISMINE))
	{
		bUserName = TRUE;
		CSize szUserName(0, 0);
		CSize szUserImage(0, 0);
		CalcUserImage(ptOffset, szUserImage);
		CalcUserName(ptOffset, szUserName);
		
		sz.cx = max(szUserName.cx, sz.cx);
		
		/*CSize szTime(0, 0);
		CalcTime(ptOffset, szTime, bUserName);
		ptOffset.y += szUserName.cy;
		sz.cy += szUserName.cy;
		sz.cx = max(szUserName.cx, sz.cx);*/
		sz.cy += szUserName.cy;
		ptOffset.y += szUserName.cy;
	}
	else
	{
		/*if (dwFlags & DEF_CHAT_MSG_TIME)
		{
			CSize szTime(0, 0);
			CalcTime(ptOffset, szTime, bUserName);
			ptOffset.y += szTime.cy;
			sz.cy += szTime.cy;
			sz.cx = max(szTime.cx, sz.cx);
		}*/
	}
	
	CRect rcView = m_pResouce->GetViewRect();
	LPChatItemInfo pInfo = m_pChatItem->GetChatItemInfo();
	CWnd* pWnd = m_pResouce->GetCurrentWnd();

	if (m_nSingleRowWith == 0)
	{
		CSize s(0, 0);
		RecalcTextRectVert(pWnd, pInfo->strMsg, m_pChatItem->GetFontFaceName(), m_pChatItem->GetFontHeight(), m_pChatItem->GetFontStyle(), CRect(0, 0, 1000000, 10000000), s);
		m_nSingleRowWith = s.cx;
	}
	
	int nSYMsg = 0;
	if (dwFlags & DEF_CHAT_MSG_ISMINE)
	{
		int nRight = rcView.right - 10;
		
		nSYMsg = DEF_CHAT_MSG_ITEM_TOP_Y;


		//nSYMsg += DEF_NAME_MSG_POS_TOP_REL_Y;

		int nCXMsg = rcView.Width() - (136 + 10);
		int nCYMsg = 0;

		CSize szMsg(0, 0);			
		CRect rtMsg(0, 0, nCXMsg, 1000);


		if (nCXMsg < m_nSingleRowWith || m_rtUserMessage.Width() < m_nSingleRowWith || m_rtUserMessage.IsRectEmpty())
		{
			RecalcTextRectVert(pWnd, pInfo->strMsg, m_pChatItem->GetFontFaceName(), 
				m_pChatItem->GetFontHeight(), m_pChatItem->GetFontStyle(), rtMsg, szMsg);
		}
		else
		{
			szMsg.cx = m_rtUserMessage.Width();
			szMsg.cy = m_rtUserMessage.Height() - DEF_CHAT_MSG_ITEM_TOP_Y;
		}


		nCXMsg = szMsg.cx + DEF_CHAT_MSG_BUBBLE_MARGIN_LEFT_X + DEF_CHAT_MSG_BUBBLE_MARGIN_RIGHT_X;
		nCYMsg = szMsg.cy;

		m_rcBubble.SetRect(nRight - nCXMsg, nSYMsg, nRight, nSYMsg + nCYMsg + nSYMsg);
		if (m_rcBubble.Width() < DEF_CHAT_MSG_BUBBLE_MIN_X)
		{
			m_rcBubble.right = m_rcBubble.left + DEF_CHAT_MSG_BUBBLE_MIN_X;
		}

		m_rtUserMessage.CopyRect(&m_rcBubble);
		m_rtUserMessage.left += DEF_CHAT_MSG_BUBBLE_MARGIN_RIGHT_X;
		//m_rtUserMessage.top += DEF_CHAT_MSG_BUBBLE_MARGIN_TOP_Y ;
		//m_rtUserMessage.bottom = m_rtUserMessage.top + szMsg.cy;
		m_rtUserMessage.right -= DEF_CHAT_MSG_BUBBLE_MARGIN_LEFT_X;

		m_rtUserMessage.OffsetRect(ptOffset);
		m_rcBubble.OffsetRect(ptOffset);

		if (dwFlags & DEF_CHAT_MSG_TIME)
		{
			CSize szTime(0, 0);
			CalcTime(ptOffset, szTime, dwFlags);
			//ptOffset.y += szTime.cy;
			//sz.cy += szTime.cy;
			sz.cx = max(szTime.cx, sz.cx);
		}

		//if (m_pChatItem->IsFailedMsg())
		if (dwFlags & DEF_CHAT_MSG_RESEND)
		{
			CSize szResendStatus = _CalcBubbleSendStatus(ptPos, dwFlags);
			sz.cx += szResendStatus.cx;
		}
		else
		{
			m_rcReSendImg.SetRectEmpty();
			m_rcSendCount.SetRectEmpty();
		}
	}
	else
	{
		int nSXMsg = DEF_ITEM_POS_LEFT_REL_X + _GetUserImageWidth() + DEF_CHAT_MSG_BUBBLE_ARROR_X;
		if (bUserName)
		{
			nSYMsg = DEF_CHAT_MSG_BUBBLE_TOP_Y;
		}
		else
		{
			//nSYMsg = DEF_CHAT_MSG_BUBBLE_USERNAME_TOP_Y;
			nSYMsg = DEF_CHAT_MSG_ITEM_TOP_Y;	
		}

		int nCXMsg = rcView.Width() - nSXMsg - DEF_CHAT_MSG_BUBBLE_ARROR_RIGHT_X;
		int nCYMsg = 0;

		CSize szMsg(0, 0);			
		CRect rtMsg(0, 0, nCXMsg, 1000);

		if (nCXMsg < m_nSingleRowWith || m_rtUserMessage.Width() < m_nSingleRowWith || m_rtUserMessage.IsRectEmpty())
		{
			RecalcTextRectVert(pWnd, pInfo->strMsg, m_pChatItem->GetFontFaceName(), 
				m_pChatItem->GetFontHeight(), m_pChatItem->GetFontStyle(), rtMsg, szMsg);
		}
		else
		{
			szMsg.cx = m_rtUserMessage.Width();
			szMsg.cy = m_rtUserMessage.Height() - DEF_CHAT_MSG_ITEM_TOP_Y;
		}

// 		RecalcTextRectVert(pWnd, pInfo->strMsg, m_pChatItem->GetFontFaceName(), m_pChatItem->GetFontHeight(), 
// 			m_pChatItem->GetFontStyle(), rtMsg, szMsg);

		nCXMsg = szMsg.cx + DEF_CHAT_MSG_BUBBLE_MARGIN_LEFT_X + DEF_CHAT_MSG_BUBBLE_MARGIN_RIGHT_X;
		nCYMsg = szMsg.cy;

		/*int nMsgStringOffsetY = 0;
		if (szMsg.cy < DEF_CHAT_MSG_BUBBLE_MIN_Y)
		{
			nCYMsg = DEF_CHAT_MSG_BUBBLE_MIN_Y;
			nMsgStringOffsetY = (DEF_CHAT_MSG_BUBBLE_MIN_Y - szMsg.cy) / 2;
		}*/

		nCYMsg += DEF_CHAT_MSG_BUBBLE_MARGIN_TOP_Y + DEF_CHAT_MSG_BUBBLE_MARGIN_BOTTOM_Y;
		m_rcBubble.SetRect(nSXMsg, 
			nSYMsg, 
			nSXMsg + nCXMsg, 
			nSYMsg + nCYMsg);

		if (m_rcBubble.Width() < DEF_CHAT_MSG_BUBBLE_MIN_X)
		{
			m_rcBubble.right = m_rcBubble.left + DEF_CHAT_MSG_BUBBLE_MIN_X;
		}

		m_rtUserMessage.CopyRect(&m_rcBubble);
		m_rtUserMessage.left += DEF_CHAT_MSG_BUBBLE_MARGIN_LEFT_X;
		//m_rtUserMessage.top += DEF_CHAT_MSG_BUBBLE_MARGIN_TOP_Y;
		m_rtUserMessage.right -= DEF_CHAT_MSG_BUBBLE_MARGIN_RIGHT_X;

		m_rtUserMessage.OffsetRect(ptOffset);
		m_rcBubble.OffsetRect(ptOffset);

		
		if (dwFlags & DEF_CHAT_MSG_TIME)
		{
			CSize szTime(0, 0);
			CalcTime(ptOffset, szTime, dwFlags);
			//ptOffset.y += szTime.cy;
			//sz.cy += szTime.cy;
			sz.cx = max(szTime.cx, sz.cx);
		}

		if (m_pChatItem->IsFailedMsg())
		{
			CSize szResendStatus = _CalcBubbleSendStatus(ptPos, dwFlags);
			sz.cx += szResendStatus.cx;
		}
		else
		{
			m_rcReSendImg.SetRectEmpty();
			m_rcSendCount.SetRectEmpty();
		}
	}
	
	

	sz.cy += m_rcBubble.Height();
	sz.cy += nSYMsg;
	sz.cx = max(sz.cx, m_rcBubble.Width());

	m_dwFlags = dwFlags;
	return sz;
}

CRect UIChatElement::_CalcPlainUserName() 
{
	int nSXName =  PLAIN_NAME_POS_LEFT_REL_X;
	int nSYName =  PLAIN_NAME_POS_TOP_REL_Y;

	CSize szName(0, 0);
	CRect rtName = m_pResouce->GetViewRect();

	CWnd* pWnd = m_pResouce->GetCurrentWnd();

	HDC hDC = pWnd->GetDC()->m_hDC;
	REAL fontHeight = m_rlPlainUserNameFont;

	RecalcTextRect(pWnd, m_pChatItem->GetChatItemInfo()->strUserName,
		g_defaultFontFaceName, fontHeight, FontStyleBold,
		rtName, szName);

	::ReleaseDC(pWnd->m_hWnd, hDC);
	return CRect(nSXName, nSYName, nSXName + szName.cx + 10, nSYName + szName.cy);
}

CSize UIChatElement::_CalcPlainSize(const CPoint& ptPos, DWORD dwFlags ) 
{
	CPoint ptOffset = ptPos;
	m_rcUserName.SetRectEmpty();
	CSize sz(0, 0);
	BOOL bUserName = dwFlags & DEF_CHAT_MSG_USERNAME;
	//if(bUserName)
	//{
		CSize szUserName(0, 0);
		CSize szUserImage(0, 0);
		CalcUserImage(ptPos,szUserImage);
		CalcUserName(ptPos, szUserName);
		sz.cx = max(sz.cx, szUserName.cx);
		sz.cy += szUserName.cy;
		ptOffset.y += szUserName.cy;
	//}
	
	CSize szTime(0, 0);
	CalcTime(ptOffset, szTime, bUserName);
	CSize szMsg = _CalcUserMessage(ptOffset);
	sz.cy += szMsg.cy;
	sz.cx = max(sz.cx, szMsg.cx);
	_CalcReSendStatus(ptOffset, sz);
	return sz;
}

CRect UIChatElement::_CalcPlainTime()
 {
	/*int nSXTime = 0;
	int nSYTime = 0;
	int nCXTime = 0;
	int nCYTime = 0;

	CSize szTime(0, 0);
	CRect rtTime = m_pResouce->GetViewRect();;

	CString strTime = GetTimeString();
	RecalcTextRect(m_pResouce->GetCurrentWnd(), strTime, m_pChatItem->GetFontFaceName(), 
		m_rlPlainTimeFont, FontStyleRegular, rtTime, szTime);

	nCXTime = szTime.cx + 5;
	nCYTime = szTime.cy;
	nSXTime = PLAIN_TIME_POS_LEFT_X;
	nSYTime = PLAIN_TIME_POS_TOP_Y + m_rcUserName.bottom;

	return CRect(nSXTime, nSYTime, nSXTime + nCXTime, nSYTime + nCYTime);*/
	 return CRect(0, 0, 0, 0);
}


void UIChatElement::_DrawBubbleChat( Graphics* graph )
{
	CPoint ptZero(0, 0);
	CPoint ptOffset = ptZero - m_pResouce->GetOffSetPoint();

	CRect rcBubble = m_rcBubble;
	rcBubble.OffsetRect(ptOffset);
	CRect rcView = m_pResouce->GetViewRect();

	if (m_dwFlags & DEF_CHAT_MSG_DATE)
	{
		DrawDate(graph);
	}

	if ((m_dwFlags & DEF_CHAT_MSG_USERNAME) && !(m_dwFlags & DEF_CHAT_MSG_ISMINE))
	{
		DrawUserName(graph);
		DrawUserImage(graph);
		DrawTime(graph,TRUE);
	}
	else
	{
		if (m_dwFlags & DEF_CHAT_MSG_TIME)
		{
			DrawTime(graph,FALSE);
		}
	}

	if (m_dwFlags & DEF_CHAT_MSG_ISMINE)
	{
		_DrawBubble(graph, rcBubble , TRUE);
	}
	else
	{
		_DrawBubble(graph, rcBubble , FALSE);
	}
	CChatMsgItem* pMsgItem = dynamic_cast<CChatMsgItem*>(m_pChatItem);

	std::vector<TextRange> vcUrl;
	pMsgItem->GetUrlVector(vcUrl);
	CRect rtUserMessage = m_rtUserMessage;
	rtUserMessage.OffsetRect(ptOffset);

	if(_IsDefaultFontAndSize())
	{
		rtUserMessage.OffsetRect(CSize(0, 1));
	}
	else
	{
		rtUserMessage.OffsetRect(CSize(0, 2));
	}

	
	LPChatItemInfo pInfo = m_pChatItem->GetChatItemInfo();

	/*Color crText;
	crText.SetFromCOLORREF(pInfo->cf.crTextColor);*/
	Color crText = CColorConvert::HEX2Color(pInfo->cf.crTextColor);
	crText = _GetMsgColor();

	//RectF rc(rtUserMessage.left,rtUserMessage.top,rtUserMessage.Width(),rtUserMessage.Height());
	//graph->DrawRectangle(&Pen(Color(0xFF,0,0)),rc);
	DrawChatText(graph, pMsgItem, pInfo->strMsg, &rcView, &rtUserMessage, 
		StringAlignmentNear, crText, pMsgItem->GetSelectRange(), vcUrl);


// 	if (m_pChatItem->IsFailedMsg())
// 	{
// 		Image* pImage = m_pResouce->GetFailMsgImage();
// 		if (pImage)
// 		{
// 			CRect rcReSend = m_rcReSendImg;
// 			rcReSend.OffsetRect(ptOffset);
// 
// 			Image* pReSendImageL = m_pResouce->GetSendStatusImage(0);
// 			Image* pReSendImageC = m_pResouce->GetSendStatusImage(1);
// 			Image* pReSendImageR = m_pResouce->GetSendStatusImage(2);
// 
// 			CRect rcImageL(rcReSend.left, rcReSend.top,
// 				rcReSend.left + pReSendImageL->GetWidth(),
// 				rcReSend.top + pReSendImageL->GetHeight());
// 
// 			CRect rcImageC(rcImageL.right, rcReSend.top,
// 				rcImageL.right + 2,
// 				rcReSend.top + pReSendImageC->GetHeight());
// 
// 			CRect rcImageR(rcImageC.right, rcReSend.top,
// 				rcImageC.right + pReSendImageL->GetWidth(),
// 				rcReSend.top + pReSendImageL->GetHeight());
// 			
// 
// 			InterpolationMode interpolationMode = graph->GetInterpolationMode();
// 			PixelOffsetMode pixelOffsetMode = graph->GetPixelOffsetMode();
// 			graph->SetInterpolationMode(InterpolationModeNearestNeighbor);
// 			graph->SetPixelOffsetMode(PixelOffsetModeHalf);
// 
// 			DrawImageToDest(graph, pReSendImageL, &rcView, &rcImageL, NULL);
// 
// 
// 			DrawImageToDest(graph, pReSendImageC, &rcView, &rcImageC, NULL);
// 			DrawImageToDest(graph, pReSendImageR, &rcView, &rcImageR, NULL);
// 
// 			graph->SetInterpolationMode(interpolationMode);
// 			graph->SetPixelOffsetMode(PixelOffsetModeHalf);
// 
// 			CRect rcSendCount = m_rcSendCount;
// 			rcSendCount.OffsetRect(ptOffset);
// 			DrawChatText(graph, m_pChatItem->GetFailCount(), 
// 				&rcView, &rcSendCount, 
// 				g_defaultFontFaceName, (REAL)DEF_SEND_COUNT_FONT_SIZE,
// 				StringAlignmentCenter, FontStyleRegular, m_crReSendCount, FALSE, 0, 0);
// 		}
// 	}
}

void UIChatElement::_DrawBubble( Graphics* graph, CRect rcBubble, BOOL bMine )
{
	Image **pImage = m_pResouce->GetBubbleImage(bMine);
	if (pImage)
	{
		RectF rc(rcBubble.left,rcBubble.top,rcBubble.Width(),rcBubble.Height());
		DrawNineBlockImage(graph,pImage,&rc);
	}
}


CSize UIChatElement::_CalcUserMessage(CPoint& ptPos)
{
	CPoint ptOffset = ptPos;
	CString strMsg = m_pChatItem->GetChatItemInfo()->strMsg;
	_CutMsgStringForLines(strMsg, m_vecMsgLines);
	CSize sz(0, 0);
	CRect rt = m_pResouce->GetViewRect();

	int nCXMSG = 0;
	int nCYMSG = 0;

	CRect rc = m_pResouce->GetViewRect();
	int nLines = m_vecMsgLines.size();
	nCXMSG =  rc.Width() - PLAIN_NAME_POS_LEFT_REL_X - PLAIN_ITEM_POS_RIGHT_PAD - _GetUserImageWidth() - DEF_ITEM_POS_LEFT_REL_X;
	
	int nMsgToName_Y = DEF_CHAT_MSG_ITEM_TOP_Y;
	if(!m_rcUserName.IsRectEmpty())
	{
		nMsgToName_Y = PLAIN_MSG_POS_TOP_Y;
	}

	if(nLines > 0)
	{
		CSize szMsg(0, 0);
		CRect rtMsg = m_pResouce->GetViewRect();;
		
		
		RecalcTextRectVert(m_pResouce->GetCurrentWnd(), m_vecMsgLines[0], m_pChatItem->GetFontFaceName(), 

					m_pChatItem->GetFontHeight(), FontStyleRegular, rtMsg, szMsg);

		int nLeft = m_rcUserImage.right + PLAIN_MESSAGE_POS_LEFT_PAD;
		//int nRight = rc.Width() - PLAIN_ITEM_POS_RIGHT_PAD;
		int nRight = nLeft + szMsg.cx;
		int nTop = m_rcUserName.bottom + nMsgToName_Y; //m_rcTime.top - (m_fontMessageHeight - m_fontTimeHeight);
		int nBottom = nTop + szMsg.cy;

		CPoint ptLeftTop(nLeft, nTop);
		/*if (nBottom - nTop > m_rcTime.Height())
		{
			//int nHeight = nBottom - nTop - m_rcTime.Height();
			int nUserMessageFontHeight = (int)m_pChatItem->GetFontHeight();
			int nPad = (nBottom - nTop - nUserMessageFontHeight) / 2 +
			nUserMessageFontHeight - 
			((m_rcTime.Height() - PLAIN_TIME_FONT_HEIGHT) / 2 + PLAIN_TIME_FONT_HEIGHT);
		    m_rcTime.top += nPad;
			m_rcTime.bottom += nPad;
		}*/

		CRect rtTemp(nLeft, nTop, nRight, nBottom);
		m_vecMsgRects.push_back(rtTemp);
			
		if(nLines > 1)
		{
			for(int i = 1; i < nLines; i++)
			{	  

				RecalcTextRectVert(m_pResouce->GetCurrentWnd(), m_vecMsgLines[i], m_pChatItem->GetFontFaceName(), 

					m_pChatItem->GetFontHeight(), FontStyleRegular, rtMsg, szMsg);

				nLeft = m_rcUserImage.right + PLAIN_MESSAGE_POS_LEFT_PAD;
				nTop = nBottom + PLAIN_MESSAGE_LINE_SPACING;
				nBottom = nTop + szMsg.cy;
				nRight = nLeft + szMsg.cx;
				rtTemp.SetRect(nLeft, nTop, nRight, nBottom);
				//rtTemp.OffsetRect(ptPos);
				m_vecMsgRects.push_back(rtTemp);
			}

		}

		nCYMSG =  m_vecMsgRects[nLines -1].bottom - m_vecMsgRects[0].top
			+ nMsgToName_Y;
		m_rtUserMessage.SetRect(ptLeftTop.x, ptLeftTop.y, ptLeftTop.x + nCXMSG, 
			ptLeftTop.y + nCYMSG);
	}
	return CSize(nCXMSG, nCYMSG);

}

void UIChatElement::_CutMsgStringForLines(
	CString strMsg, 
	vector<CString>& vecMsgLines)
{	
	FUNCTION_BLOCK_TRACE(10);
	CRect rc = m_pResouce->GetViewRect();
	int	nFirstLinePixel = rc.Width() - PLAIN_ITEM_POS_RIGHT_PAD - 
		m_rcUserImage.right - PLAIN_MESSAGE_POS_LEFT_PAD;
	int nNextLinePixel  =	nFirstLinePixel;
	if (nFirstLinePixel <= 0)
	{
		return;
	}


	CString strFirstLine, strOtherLine;
	strOtherLine = strMsg;
	int nMax = 1;
	int nMin = 1;
	int nMid = 1;

	CSize sz(0, 0);


    DWORD dwTick = GetTickCount();
	while(TRUE)
	{	
		int strLength = strOtherLine.GetLength();
		bool bLongerThanLineLmite = false;
		bool bEnterInFirstLine = false;
		nMax = strOtherLine.GetLength();

		CString str;
		int nEnterPos = strOtherLine.Find(_T("\n"));
		if(nEnterPos >= 0)
		{
			str = strOtherLine.Left(nEnterPos + 1);
			RecalcTextRectVert(m_pResouce->GetCurrentWnd(), str, m_pChatItem->GetFontFaceName(), 
				m_pChatItem->GetFontHeight(), m_pChatItem->GetFontStyle(), rc, sz, FALSE);
		
			if(sz.cx <= nFirstLinePixel)
			{
				strFirstLine = str;
				strOtherLine = strOtherLine.Right(strLength - nEnterPos - 1);
				vecMsgLines.push_back(strFirstLine);
				nFirstLinePixel = nNextLinePixel;
				continue;
			}
		}
	
		str = strOtherLine;
		RecalcTextRectVert(m_pResouce->GetCurrentWnd(), str, m_pChatItem->GetFontFaceName(), 
			m_pChatItem->GetFontHeight(), m_pChatItem->GetFontStyle(), rc, sz, FALSE);

		if(sz.cx <= nFirstLinePixel)
		{
			 vecMsgLines.push_back(strOtherLine);
			 break;
		}

		while(nMax > nMin)
		{
			nMid = (nMax + nMin) / 2;

			if(nMid == nMin || nMid == nMax)
			{
				break;
			}

			str = strOtherLine.Left(nMid);
			
			RecalcTextRectVert(m_pResouce->GetCurrentWnd(), str, m_pChatItem->GetFontFaceName(), 
				m_pChatItem->GetFontHeight(), m_pChatItem->GetFontStyle(), rc, sz, FALSE);

			if(sz.cx  > nFirstLinePixel)
			{
				nMax = nMid;
			}
			else if(sz.cx  < nFirstLinePixel)
			{
				nMin = nMid;
			}
			else
			{
				break;
			}

		}

		strFirstLine = strOtherLine.Left(nMid);
		strOtherLine = strOtherLine.Right(strLength - nMid);
		vecMsgLines.push_back(strFirstLine);
		nFirstLinePixel = nNextLinePixel;
	}



		/*
		strMsg = strOtherLine;
		int strLength = strMsg.GetLength();
		bool bLongerThanLineLmite = false;
		bool bEnterInFirstLine = false;
		for(int i = 0; i < strLength; i++)
		{
			CString str = strMsg.Left(i + 1);
			CSize sz(0, 0);
			CRect rt(0, 0, 500, 500);

			RecalcTextRectVert(m_pResouce->GetCurrentWnd(), str, m_pChatItem->GetFontFaceName(), 
				m_pChatItem->GetFontHeight(), m_pChatItem->GetFontStyle(), rt, sz);
			if(sz.cx  > nFirstLinePixel)
			{
				bLongerThanLineLmite = true;
				strFirstLine = strMsg.Left(i);
				strOtherLine = strMsg.Right(strLength - i);
				int nEnterPos = strFirstLine.Find(_T("\n"));
				if(nEnterPos >= 0)
				{	
					strFirstLine = strMsg.Left(nEnterPos -1);
					strOtherLine = strMsg.Right(strLength - nEnterPos - 1);
					
				}
				vecMsgLines.push_back(strFirstLine);
				break;
			}
			else
			{
			    int nEnterPos = strOtherLine.Find(_T("\n"));
				if(nEnterPos >= 0)
				{
					bEnterInFirstLine = true;
					CString strTemp = strMsg.Left(nEnterPos -1);
					RecalcTextRectVert(m_pResouce->GetCurrentWnd(), strTemp, m_pChatItem->GetFontFaceName(), 
						m_pChatItem->GetFontHeight(), m_pChatItem->GetFontStyle(), rt, sz);
					if(sz.cx + 10 > nFirstLinePixel)
					{
						continue;
					}
					strFirstLine = strTemp;
					strOtherLine = strMsg.Right(strLength - nEnterPos - 1);
					vecMsgLines.push_back(strFirstLine);
					break;
				}
			}
		}

		nFirstLinePixel =	rc.Width() - PLAIN_ITEM_POS_RIGHT_PAD - PLAIN_TIME_POS_LEFT_X;
		if(!bLongerThanLineLmite && !bEnterInFirstLine)
		{
			strFirstLine = strMsg;
			strOtherLine = _T("");
			vecMsgLines.push_back(strFirstLine);
			break;
		}
	}  */
}



void UIChatElement::_DrawUserMessage(Graphics* graph, CRect rtPS )
{
	FUNCTION_BLOCK_TRACE(10);
	int nLines = m_vecMsgLines.size();
	int nRects = m_vecMsgRects.size();

	if(nLines < 0 || (nLines != nRects))
	{
		return;
	}
	CChatMsgItem* pMsgItem = dynamic_cast<CChatMsgItem*>(m_pChatItem);
	LPTextRange lpRange = pMsgItem->GetSelectRange();
	//TRACE(TEXT("draw lpRange = [%d - %d]\n"), lpRange->nStart, lpRange->nEnd);
	vector<TextRange> textRangeUrl;
	pMsgItem->GetUrlVector(textRangeUrl);

	CPlainUrl plainUrl(m_vecMsgLines, m_vecMsgRects, textRangeUrl);
	plainUrl.Extract();
	int nLinebegin = 0;	
	//CString strOutPut;
	//strOutPut.Format(L"Draw Begin----------------\n");
	//OutputDebugString(strOutPut);
	for(int i = 0; i < nLines; i++)
	{
		TextRange range;
		CPoint ptZero(0, 0);
		CPoint ptOffset = ptZero - m_pResouce->GetOffSetPoint();
		CRect rcTmp = m_vecMsgRects[i];
		rcTmp.OffsetRect(ptOffset);

		int nLineEnd = nLinebegin + m_vecMsgLines[i].GetLength() - 1;
		lpRange->Normalize();
		/*if(lpRange->nStart == lpRange->nEnd)
		{
		   lpRange->Reset();
		}*/

		if(lpRange->IsValid())
		{
			
			if(lpRange->nStart >= nLinebegin && lpRange->nStart <= nLineEnd)
			{
				range.nStart = lpRange->nStart - nLinebegin;
			}
			else
			{
				range.nStart = 0;
			}
			if(lpRange->nEnd >= nLinebegin && lpRange->nEnd <= nLineEnd)
			{
				range.nEnd = lpRange->nEnd - nLinebegin;
			}
			else
			{
				range.nEnd =  m_vecMsgLines[i].GetLength() - 1;
			}

			if(lpRange->nStart > nLineEnd || lpRange->nEnd < nLinebegin)
			{
				range.Reset();
			}

			//strOutPut.Format(L"Line:%d--begin:%d--end:%d\n", i, range.nStart, range.nEnd);
			//OutputDebugString(strOutPut);
		}
		
		/*if(range.nStart == range.nEnd)
		{
		   range.Reset();
		}  */
		vector<TextRange> urlRangesPerLine = plainUrl.GetUrlRangeByLine(i);
		//range.nEnd--;


		LPChatItemInfo pInfo = m_pChatItem->GetChatItemInfo();
		/*Color crText;
		crText.SetFromCOLORREF(pInfo->cf.crTextColor);*/
        Color crText = CColorConvert::HEX2Color(pInfo->cf.crTextColor);
		crText = _GetMsgColor();
		DrawChatText(graph, m_vecMsgLines[i], &rtPS, &rcTmp, m_pChatItem->GetFontFaceName(), 
		m_pChatItem->GetFontHeight(), StringAlignmentNear, m_pChatItem->GetFontStyle(), 
		crText, &range, urlRangesPerLine , FALSE);
		
		nLinebegin = nLineEnd + 1;

		//OutputDebugString(strOutPut);

	}

}

void UIChatElement::_Clear()
{
	m_vecMsgLines.clear();
	m_vecMsgRects.clear();
}

void UIChatElement::_SetChatSelectedItem(CPoint ptStart, CPoint ptEnd, BOOL bSelectWord)
{
	CString strMsg = m_pChatItem->GetChatItemInfo()->strMsg;
	CChatMsgItem* pMsgItem = dynamic_cast<CChatMsgItem*>(m_pChatItem);
	ASSERT(pMsgItem);
	
	if (pMsgItem)
	{
		//TRACE(TEXT("ptStart=(%d,%d), ptEnd=(%d,%d), m_rtUserMessage={%d,%d-%d,%d, %d x %d}, strMsgLen=%d\n"),
		//	ptStart.x, ptStart.y, ptEnd.x, ptEnd.y, 
		//	m_rtUserMessage.left, m_rtUserMessage.top, m_rtUserMessage.right, m_rtUserMessage.bottom,
		//	m_rtUserMessage.Width(), m_rtUserMessage.Height(),
		//	strMsg.GetLength()
		//	);
		LPTextRange pTextRange = pMsgItem->GetSelectRange();
		
		pTextRange->Reset();
		int nSelStart = -1;
		int nSelEnd = -1;
		int nTop = 0;
		int nBottom = 0;

		int nDisplayType = m_pResouce->GetChatDisplayType();
		if(CHAT_BUBBLE == nDisplayType)

		{
			nTop = m_rtUserMessage.top;
			nBottom = m_rtUserMessage.bottom;
		}
		else if(CHAT_PLAIN == nDisplayType)
		{
			/*if(m_vecMsgRects.size() == 0 || m_vecMsgLines.size() == 0)
			{
				return;
			}
			nTop =	((CRect)*m_vecMsgRects.begin()).top;
			nBottom = ((CRect)*m_vecMsgRects.rbegin()).bottom;*/
			return _SetPlainChatSelectedItem(ptStart, ptEnd, bSelectWord);
		}

		int nMsgLength = strMsg.GetLength();

		if (ptStart.y < nTop)
		{
			if (ptEnd.y <= nTop)
			{
				//Select None, do nothing
			}
			else if(ptEnd.y > nBottom)
			{
				//Select All
				nSelStart = 0;
				nSelEnd = nMsgLength - 1;
			}
			else
			{
				//Select Part
				nSelStart = 0;
				nSelEnd = _GetStringIndexUnderPoint(ptEnd, nDisplayType);
				
				if (-1 == nSelEnd)
				{
					nSelEnd = nMsgLength - 1;
				}
			}
		}
		else if(ptStart.y < nBottom)
		{
			nSelStart = _GetStringIndexUnderPoint(ptStart, nDisplayType);
			if (-1 == nSelStart)
			{
				nSelStart = 0;
			}
			if (ptEnd.y < nBottom)
			{
				nSelEnd = _GetStringIndexUnderPoint(ptEnd, nDisplayType);
				if (-1 == nSelEnd)
				{
					nSelEnd = nMsgLength - 1;
				}
			}
			else
			{
				//Select All
				nSelEnd = nMsgLength - 1;
			}
		}
		else
		{
			//Select None, do thing
		}

		if (nSelStart > 0 && bSelectWord)
		{
			CString leftString = strMsg.Mid(0, nSelStart);

			int nIndex = leftString.ReverseFind(' ');
			if (-1 >= nIndex)
			{
				nSelStart = 0;
			}
			else
			{
				nSelStart = nIndex + 1;
			}

			nSelEnd = strMsg.Find(' ', nSelStart);
			if (-1 == nSelEnd)
			{
				nSelEnd = nMsgLength - 1;
			}
		}
		pTextRange->nStart = nSelStart;
		pTextRange->nEnd = nSelEnd;
		
		//if (ptStart.y <= m_rtUserMessage.top && ptEnd.y >= m_rtUserMessage.bottom)
		//{
		//	//select all
		//	pTextRange->nStart = 0;
		//	pTextRange->nEnd = strMsg.GetLength() - 1;
		//}
		//else if(ptStart.y > m_rtUserMessage.bottom || ptEnd.y < m_rtUserMessage.top )
		//{
		//	//Select None
		//	pTextRange->Reset();
		//}
		//else
		//{
		//	//Select part or none
		//	if (m_rtUserMessage.PtInRect(ptStart))
		//	{
		//		int nStrIndex = _GetStringIndexUnderPoint(ptStart);
		//		if (nStrIndex >= 0)
		//		{
		//			pTextRange->nStart = nStrIndex;
		//		}
		//	}
		//	else
		//	{
		//		if (m_rt)
		//		{
		//		}
		//	}
		//	if (m_rtUserMessage.PtInRect(ptEnd))
		//	{
		//		int nEndIndex = _GetStringIndexUnderPoint(ptEnd);
		//		if (nEndIndex >= 0)
		//		{
		//			pTextRange->nEnd = nEndIndex;
		//		}
		//	}
		//	else
		//	{

		//	}
		//}
		//_CheckUserMessageRange(ptStart, ptEnd, pTextRange);
		pTextRange->Normalize();
		//TRACE(TEXT("pTextRange = [%d - %d]\n"), pTextRange->nStart, pTextRange->nEnd);
	}
}

int UIChatElement::_GetStringIndexUnderPoint(CPoint point, int nDisplayType)
{
	if(CHAT_PLAIN == nDisplayType)
	{
		return _GetStringPosFormPoint(point);
	}
	CChatMsgItem* pMsgItem = dynamic_cast<CChatMsgItem*>(m_pChatItem);

	CString strMsg = m_pChatItem->GetChatItemInfo()->strMsg;

	if (strMsg.IsEmpty())
		return -1;

	CDC *pDC = m_pResouce->GetCurrentWnd()->GetDC();

	if (!pDC)
		return -1;

	Graphics graph(pDC->m_hDC);

	Gdiplus::Font myFont(m_pChatItem->GetFontFaceName(), m_pChatItem->GetFontHeight(), m_pChatItem->GetFontStyle());
	StringFormat format;
	format.SetAlignment(StringAlignmentNear);
	format.SetLineAlignment(StringAlignmentCenter);

	RectF layoutRect((Gdiplus::REAL)m_rtUserMessage.left, (Gdiplus::REAL)m_rtUserMessage.top,
		(Gdiplus::REAL)m_rtUserMessage.Width(), (Gdiplus::REAL)m_rtUserMessage.Height());

	CharacterRange range = CharacterRange(0, strMsg.GetLength());
	format.SetMeasurableCharacterRanges(1, &range);

	Region selectedRgn;
	graph.MeasureCharacterRanges(strMsg, strMsg.GetLength(), &myFont, layoutRect, &format, 1, &selectedRgn);

	if (!selectedRgn.IsVisible(point.x, point.y, &graph))
	{
		m_pResouce->GetCurrentWnd()->ReleaseDC(pDC);
		return -1;
	}

	int nMin = 0;
	int nMax = strMsg.GetLength();
	int nMid = 0;

	while (nMin < nMax)
	{
		nMid = (nMin + nMax) / 2;

		if (nMid == nMin || nMid == nMax)
			break;

		range = CharacterRange(nMin, nMid - nMin);
		format.SetMeasurableCharacterRanges(1, &range);

		graph.MeasureCharacterRanges(strMsg, strMsg.GetLength(), &myFont, layoutRect, &format, 1, &selectedRgn);

		if (selectedRgn.IsVisible(point.x, point.y, &graph))
		{
			nMax = nMid;
		}
		else
		{
			nMin = nMid;
		}
	}

	m_pResouce->GetCurrentWnd()->ReleaseDC(pDC);
	return nMid;

}



BOOL UIChatElement::_IsPointInPlainSelectionRects( const CPoint& ptPos )
{
	CPoint pt = ptPos;
	for(size_t i = 0; i < m_vecMsgRects.size(); i++)
	{
		if (m_vecMsgRects[i].PtInRect(pt))
		{
			return TRUE;
		}
	}

	return FALSE;
}

BOOL UIChatElement::_GetStringPosFormPoint( CPoint& ptPos, int& nLine, int& nIndexOfLine)
{
	//ptPos.x = 40;
	CString str;

	 nLine = 0;
	 for(size_t i = 0; i < m_vecMsgRects.size(); i++)
	 {
		 CRect rcTemp = m_vecMsgRects[i];
		 //rcTemp.bottom += 10;
		 if (m_vecMsgRects[i].PtInRect(ptPos))
		 {
			 nLine = i + 1;
			 break;
		 }
	 }
	 
	 if(nLine <= 0)
	 {
		 return FALSE;
	 }


	 CString strMsg = m_vecMsgLines[nLine -1];

	 if (strMsg.IsEmpty())
	 {
		 return FALSE;
	 }
	 
		 CDC *pDC = m_pResouce->GetCurrentWnd()->GetDC();

		 if (!pDC)
			 return FALSE;

		 Graphics graph(pDC->m_hDC);

		 Gdiplus::Font myFont(m_pChatItem->GetFontFaceName(), m_pChatItem->GetFontHeight(), m_pChatItem->GetFontStyle());
		 StringFormat format;
		 format.SetAlignment(StringAlignmentNear);

		 format.SetFormatFlags(StringFormatFlagsNoWrap);

		 RectF layoutRect((Gdiplus::REAL)m_vecMsgRects[nLine-1].left, (Gdiplus::REAL)m_vecMsgRects[nLine-1].top,
			 (Gdiplus::REAL)m_vecMsgRects[nLine-1].Width(), (Gdiplus::REAL)m_vecMsgRects[nLine-1].Height());

		 CharacterRange range = CharacterRange(0, strMsg.GetLength());
		 format.SetMeasurableCharacterRanges(1, &range);

		 Region selectedRgn;
		 graph.MeasureCharacterRanges(strMsg, strMsg.GetLength(), &myFont, layoutRect, &format, 1, &selectedRgn);

		 if (!selectedRgn.IsVisible(ptPos.x, ptPos.y, &graph))
		 {
			 m_pResouce->GetCurrentWnd()->ReleaseDC(pDC);
			 /*if(m_vecMsgRects[i].left * 2 > ptPos.x )
			 {
				 nIndexOfLine = 0;
			 }
			 else if(m_vecMsgRects[i].right< ptPos.x * 2 )
			 {
				 nIndexOfLine = strMsg.GetLength();
			 }	*/
			 //OutputDebugString(_T("______________FALSE_____________"));
			 return FALSE;
		 }

		 int nMin = 0;
		 int nMax = strMsg.GetLength();
		 int nMid = 0;
		 /*if(nMax == 1)
		 {
			 range = CharacterRange(nMin, nMid - nMin);
			 format.SetMeasurableCharacterRanges(1, &range);

			 graph.MeasureCharacterRanges(strMsg, strMsg.GetLength(), &myFont, layoutRect, &format, 1, &selectedRgn);
			 
			 selectedRgn.GetBounds()
		 }*/
		 while (nMin < nMax)
		 {
			 nMid = (nMin + nMax) / 2;

			 if (nMid == nMin || nMid == nMax)
				 break;

			 range = CharacterRange(nMin, nMid - nMin);
			 format.SetMeasurableCharacterRanges(1, &range);
			 format.SetFormatFlags(StringFormatFlagsNoWrap);
			 graph.MeasureCharacterRanges(strMsg, strMsg.GetLength(), &myFont, layoutRect, &format, 1, &selectedRgn);

			 if (selectedRgn.IsVisible(ptPos.x, ptPos.y, &graph))
			 {
				 nMax = nMid;
			 }
			 else
			 {
				 nMin = nMid;
			 }
		 }

		 m_pResouce->GetCurrentWnd()->ReleaseDC(pDC);
		 nIndexOfLine = nMid;
		/* if(nIndexOfLine == -1)
		 {
			nIndexOfLine = strMsg.GetLength();
		 }   */
		 /*if(nMid == 13)
		 {
			 int i = 0;
			 i++;
		 }	*/
		 
		 return TRUE;

}

int UIChatElement::_GetStringPosFormPoint( const CPoint& ptPos )
{
	int nLine = 0;
	int nIndex = 0;
	int nStrPos = 0;
	CPoint x = ptPos;
	if(_GetStringPosFormPoint(x, nLine, nIndex))
	{
		for(int i = 0; i < nLine - 1; i++)
		{
			nStrPos += m_vecMsgLines[i].GetLength();
		}
		nStrPos += nIndex;
	}
	else
	{
		nStrPos = -1;
	}

	/*if(-1 == nStrPos)
	{
	   nStrPos = 0;
	}*/
	return nStrPos;
}

void UIChatElement::_SetPlainChatSelectedItem( CPoint ptStart, CPoint ptEnd, BOOL bSelectWord )
{
	CString strMsg = m_pChatItem->GetChatItemInfo()->strMsg;
	CChatMsgItem* pMsgItem = dynamic_cast<CChatMsgItem*>(m_pChatItem);
	ASSERT(pMsgItem);
	
	if (pMsgItem)
	{

		LPTextRange pTextRange = pMsgItem->GetSelectRange();
		
		pTextRange->Reset();
		int nSelStart = -1;
		int nSelEnd = -1;
		int nTop = 0;
		int nBottom = 0;


		if(m_vecMsgRects.size() == 0 || m_vecMsgLines.size() == 0)
		{
			return;
		}
		nTop =	((CRect)*m_vecMsgRects.begin()).top;
		nBottom = ((CRect)*m_vecMsgRects.rbegin()).bottom;

		int nMsgLength = strMsg.GetLength();

		if (ptStart.y < nTop || _IsPointInPlainUserMassageLeftCorner(ptStart))
		{
			if (ptEnd.y <= nTop || _IsPointInPlainUserMassageLeftCorner(ptEnd))
			{
				//Select None, do nothing
			}
			else if(ptEnd.y > nBottom)
			{
				//Select All
				nSelStart = 0;
				nSelEnd = nMsgLength - 1;
			}
			else
			{
				//Select Part
				nSelStart = 0;
				nSelEnd = _GetStringIndexUnderPoint(ptEnd, CHAT_PLAIN);
				if (-1 == nSelEnd)
				{
					nSelEnd = nMsgLength - 1;
				}
			}
		}
		else if(ptStart.y < nBottom)
		{	
			/*if(ptEnd.y < nTop)
			{
			   nSelStart = 0;
			   nSelEnd = _GetStringIndexUnderPoint(ptStart, CHAT_PLAIN);
				if (-1 == nSelEnd)
				{
					nSelEnd = nMsgLength - 1;
				}
			}  */

			nSelStart = _GetStringIndexUnderPoint(ptStart, CHAT_PLAIN);
			if (-1 == nSelStart)
			{
				nSelStart = 0;
			}
			if (ptEnd.y < nBottom)
			{
				nSelEnd = _GetStringIndexUnderPoint(ptEnd, CHAT_PLAIN);
				if (-1 == nSelEnd)
				{
					nSelEnd = nMsgLength - 1;
				}
			}
			else
			{
				//Select All
				nSelEnd = nMsgLength - 1;
			}
		}
		else
		{
			//Select None, do thing
		}

		if (nSelStart > 0 && bSelectWord)
		{
			CString leftString = strMsg.Mid(0, nSelStart);

			int nIndex = leftString.ReverseFind(' ');
			if (-1 >= nIndex)
			{
				nSelStart = 0;
			}
			else
			{
				nSelStart = nIndex + 1;
			}

			nSelEnd = strMsg.Find(' ', nSelStart);
			if (-1 == nSelEnd)
			{
				nSelEnd = nMsgLength - 1;
			}
		}
		pTextRange->nStart = nSelStart;
		pTextRange->nEnd = nSelEnd;
		
		//_CheckUserMessageRange(ptStart, ptEnd, pTextRange);
		pTextRange->Normalize();
		//TRACE(TEXT("pTextRange = [%d - %d]\n"), pTextRange->nStart, pTextRange->nEnd);
	}
}


void UIChatElement::OnLButtonUp( UINT nFlags, CPoint point )
{
	if (m_pResouce->IsMouseSelection())
	{
		CPoint ptSelectionStart = m_pResouce->GetSelectionStartPoint();

		if (abs(ptSelectionStart.x - point.x) <= 1 && abs(ptSelectionStart.y - point.y) <= 1)
		{
			if (m_rcReSendImg.PtInRect(point))
			{	
				CChatModel *pChatModel = m_pChatMainView->GetChatModel();
				if (pChatModel->GetMyID().CompareNoCase(m_pChatItem->GetUserId()) == 0
					&&  m_pChatItem->IsFailedMsg() 
					&& IsEnableRetryButton())
				{
					if (!m_pChatItem->IsGroupUserChat()
						&&pChatModel->CheckSessionCreateStatus(SESSION_SUCCESS)
						&& pChatModel->GetOfflineUserCount() == 0)
					{
						m_pResouce->ResendChatItem(m_pChatItem);
					}
				}
			}
			else
			{
				CChatMsgItem* pMsgItem = dynamic_cast<CChatMsgItem*>(m_pChatItem);
				int nCurPos = _GetStringIndexUnderPoint(point, m_pResouce->GetChatDisplayType());
				if (nCurPos >= 0)
				{
					CString strUrl = pMsgItem->GetUrlString(nCurPos);
					if (!strUrl.IsEmpty())
					{
						m_pResouce->OpenHyperLink(strUrl);
					}
				}
			}
		}
	}
}

CSize UIChatElement::_CalcReSendStatus( const CPoint& ptPos, CSize& sz )
{
	CSize szRet(0, 0);
	int nWidth = (m_pResouce->GetSendStatusImage(0)->GetWidth() + 
		2 + 
		m_pResouce->GetSendStatusImage(2)->GetWidth());

	m_rcReSendImg.left = m_rcUserName.right + PLAIN_STATUS_LEFT_X;
	m_rcReSendImg.right = m_rcReSendImg.left + nWidth;

	m_rcReSendImg.top = m_rcUserName.top;
	m_rcReSendImg.bottom = m_rcReSendImg.top + m_pResouce->GetSendStatusImage(0)->GetHeight();
	

// 	CSize szTime(0, 0);
// 	CRect rtTime(0, 0, 500, 500);
// 	REAL fontSize = DEF_SEND_COUNT_FONT_SIZE;
// 	RecalcTextRect(m_pResouce->GetCurrentWnd(), m_pChatItem->GetFailCount(),
// 		g_defaultFontFaceName, fontSize, FontStyleRegular, rtTime, szTime);

// 	m_rcSendCount.left = (m_rcReSendImg.Width() - szTime.cx) / 2 + m_rcReSendImg.left;
// 	m_rcSendCount.right = m_rcSendCount.left + szTime.cx;
// 	m_rcSendCount.top = (m_rcReSendImg.Height() - szTime.cy) / 2 + m_rcReSendImg.top + 1;
// 	m_rcSendCount.bottom = m_rcSendCount.top + szTime.cy;
// 	m_rcSendCount.OffsetRect(-1,-1);

// 	szRet.cy = m_rcReSendImg.Height();
// 	szRet.cx = m_rcReSendImg.Width() + BUBBLE_STATUS_MARGIN_X;

	return CSize(0,0);
}
// 
// void UIChatElement::DrawRetryStatus(Graphics* graph, CRect rcPS)
// {
// 	if (!m_pChatItem->IsFailedMsg())
// 	{
// 		return;
// 	}
// 
// 	CRect rcView = m_pResouce->GetViewRect();
// 
// 	CRect rcReSend = rcPS;
// 
// 	if (!m_pChatItem->IsGroupUserChat())
// 	{
// 		Image* pReSendImageL = m_pResouce->GetSendStatusImage(0);
// 		Image* pReSendImageC = m_pResouce->GetSendStatusImage(1);
// 		Image* pReSendImageR = m_pResouce->GetSendStatusImage(2);
// 
// 		CRect rcImageL(rcReSend.left, rcReSend.top,
// 			rcReSend.left + pReSendImageL->GetWidth(),
// 			rcReSend.top + pReSendImageL->GetHeight());
// 
// 		CRect rcImageC(rcImageL.right, rcReSend.top,
// 			rcImageL.right + 2,
// 			rcReSend.top + pReSendImageC->GetHeight());
// 
// 		CRect rcImageR(rcImageC.right, rcReSend.top,
// 			rcImageC.right + pReSendImageL->GetWidth(),
// 			rcReSend.top + pReSendImageL->GetHeight());
// 
// 		InterpolationMode interpolationMode = graph->GetInterpolationMode();
// 		PixelOffsetMode pixelOffsetMode = graph->GetPixelOffsetMode();
// 		graph->SetInterpolationMode(InterpolationModeNearestNeighbor);
// 		graph->SetPixelOffsetMode(PixelOffsetModeHalf);
// 
// 		DrawImageToDest(graph, pReSendImageL, &rcView, &rcImageL, NULL);
// 		DrawImageToDest(graph, pReSendImageC, &rcView, &rcImageC, NULL);
// 		DrawImageToDest(graph, pReSendImageR, &rcView, &rcImageR, NULL);
// 		graph->SetInterpolationMode(interpolationMode);
// 		graph->SetPixelOffsetMode(pixelOffsetMode);
// 
// 
// 	}
// 	else
// 	{
// 		Image* pReSendImage = m_pResouce->GetSendStatusImage(3);
// 
// 		if (pReSendImage)
// 		{
// 			CRect rcImage(rcReSend.left, rcReSend.top,
// 				rcReSend.left + pReSendImage->GetWidth(),
// 				rcReSend.top + pReSendImage->GetHeight());
// 
// 			InterpolationMode interpolationMode = graph->GetInterpolationMode();
// 			PixelOffsetMode pixelOffsetMode = graph->GetPixelOffsetMode();
// 			graph->SetInterpolationMode(InterpolationModeNearestNeighbor);
// 			graph->SetPixelOffsetMode(PixelOffsetModeHalf);
// 
// 			DrawImageToDest(graph, pReSendImage, &rcView, &rcImage, NULL);
// 
// 			graph->SetInterpolationMode(interpolationMode);
// 			graph->SetPixelOffsetMode(pixelOffsetMode);
// 		}
// 
// 	}
// 	
// 	CPoint ptZero(0, 0);
// 	CPoint ptOffset = ptZero - m_pResouce->GetOffSetPoint();
// 	CRect rcSendCount = m_rcSendCount;
// 	rcSendCount.OffsetRect(ptOffset);
// 	DrawChatText(graph, m_pChatItem->GetFailCount(), 
// 		&rcView, &rcSendCount, 
// 		g_defaultFontFaceName, (REAL)DEF_SEND_COUNT_FONT_SIZE,
// 		StringAlignmentCenter, FontStyleRegular, m_crReSendCount, FALSE, 0, 0);
// 
// }

void UIChatElement::_DrawReSendStatus(Graphics* graph, CRect rcPS)
{
	CPoint ptZero(0, 0);
	CPoint ptOffset = ptZero - m_pResouce->GetOffSetPoint();
	CRect rcView = m_pResouce->GetViewRect();

	if (m_pChatItem->IsFailedMsg())
	{
		Image* pImage = m_pResouce->GetFailMsgImage();
		if (pImage)
		{
			CRect rcReSend = m_rcReSendImg;
			rcReSend.OffsetRect(ptOffset);

			Image* pReSendImageL = m_pResouce->GetSendStatusImage(0);
			Image* pReSendImageC = m_pResouce->GetSendStatusImage(1);
			Image* pReSendImageR = m_pResouce->GetSendStatusImage(2);

			CRect rcImageL(rcReSend.left, rcReSend.top,
				rcReSend.left + pReSendImageL->GetWidth(),
				rcReSend.top + pReSendImageL->GetHeight());

			CRect rcImageC(rcImageL.right, rcReSend.top,
				rcImageL.right + 2,
				rcReSend.top + pReSendImageC->GetHeight());

			CRect rcImageR(rcImageC.right, rcReSend.top,
				rcImageC.right + pReSendImageL->GetWidth(),
				rcReSend.top + pReSendImageL->GetHeight());

			InterpolationMode interpolationMode = graph->GetInterpolationMode();
			PixelOffsetMode pixelOffsetMode = graph->GetPixelOffsetMode();
			graph->SetInterpolationMode(InterpolationModeNearestNeighbor);
			graph->SetPixelOffsetMode(PixelOffsetModeHalf);

			DrawImageToDest(graph, pReSendImageL, &rcView, &rcImageL, NULL);
			DrawImageToDest(graph, pReSendImageC, &rcView, &rcImageC, NULL);
			DrawImageToDest(graph, pReSendImageR, &rcView, &rcImageR, NULL);
			graph->SetInterpolationMode(interpolationMode);
			graph->SetPixelOffsetMode(pixelOffsetMode);

			CRect rcSendCount = m_rcSendCount;
			rcSendCount.OffsetRect(ptOffset);
			DrawChatText(graph, m_pChatItem->GetFailCount(), 
				&rcView, &rcSendCount, 
				g_defaultFontFaceName, (REAL)DEF_SEND_COUNT_FONT_SIZE,
				StringAlignmentCenter, FontStyleRegular, m_crReSendCount, FALSE, 0, 0);
		}
	}
}

BOOL UIChatElement::_IsPointInPlainUserMassageLeftCorner(const CPoint& ptPos)
{
	if(m_vecMsgRects.size() == 0)
	{
		return FALSE;
	}

	CRect rcFirstLine = m_vecMsgRects[0];

	if(ptPos.y > rcFirstLine.top && ptPos.y < rcFirstLine.bottom &&
		ptPos.x < rcFirstLine.left)
	{
		return TRUE;
	}
	
	return FALSE;
}

CSize UIChatElement::_CalcBubbleSendStatus( const CPoint& ptPos, DWORD dwFlags )
{
	CSize szRet(0, 0);
	int nWidth = (m_pResouce->GetSendStatusImage(0)->GetWidth() + 
		2 + 
		m_pResouce->GetSendStatusImage(2)->GetWidth());

	if(dwFlags & DEF_CHAT_MSG_ISMINE)
	{
		if((dwFlags & DEF_CHAT_MSG_TIME))
		{
			m_rcReSendImg.right = m_rcTime.left - BUBBLE_STATUS_MARGIN_X;
		}
		else
		{
			m_rcReSendImg.right = m_rcBubble.left - BUBBLE_TIME_MARGIN_X;
		}

		m_rcReSendImg.left = m_rcReSendImg.right - nWidth;
			
	}
	else
	{
		if((dwFlags & DEF_CHAT_MSG_TIME))
		{
			m_rcReSendImg.left = m_rcTime.right + BUBBLE_STATUS_MARGIN_X;
		}
		else
		{
			m_rcReSendImg.left = m_rcBubble.right + BUBBLE_TIME_MARGIN_X;
		}
		m_rcReSendImg.right = m_rcReSendImg.left + nWidth;
	}



	CSize szTime(0, 0);
	CRect rtTime(0, 0, 500, 500);
	REAL fontSize = DEF_SEND_COUNT_FONT_SIZE;
	RecalcTextRect(m_pResouce->GetCurrentWnd(), m_pChatItem->GetFailCount(),
		g_defaultFontFaceName, fontSize, FontStyleRegular, rtTime, szTime);

	if((dwFlags & DEF_CHAT_MSG_TIME))
	{
		m_rcReSendImg.top = m_rcTime.top - (((int)m_pResouce->GetSendStatusImage(0)->GetHeight() - m_rcTime.Height()) / 2);
		m_rcReSendImg.bottom = m_rcReSendImg.top + m_pResouce->GetSendStatusImage(0)->GetHeight();
		
	}
	else
	{
		m_rcReSendImg.bottom = m_rcBubble.bottom - BUBBLE_TIME_MARGIN_Y;
		m_rcReSendImg.top = m_rcReSendImg.bottom - szTime.cy;
	}


// 	m_rcSendCount.left = (m_rcReSendImg.Width() - szTime.cx) / 2 + m_rcReSendImg.left;
// 	m_rcSendCount.right = m_rcSendCount.left + szTime.cx;
// 	m_rcSendCount.top = (m_rcReSendImg.Height() - szTime.cy) / 2 + m_rcReSendImg.top;
// 	m_rcSendCount.bottom = m_rcSendCount.top + szTime.cy;
// 	//m_rcSendCount.OffsetRect(0,-2);

	szRet.cy = m_rcReSendImg.Height();
	szRet.cx = m_rcReSendImg.Width() + BUBBLE_STATUS_MARGIN_X;

	return szRet;
}

Color UIChatElement::_GetMsgColor()
{
	Color crText = DEF_CHAT_BLACK_TXT_COLOR;

	if(CHAT_BUBBLE == m_pResouce->GetChatDisplayType())
	{
		if (m_dwFlags & DEF_CHAT_MSG_ISMINE)
		{
			crText = DEF_CHAT_WHITE_TXT_COLOR;
		}
	}

	return crText;
}

BOOL UIChatElement::_IsDefaultFontAndSize()
{
	REAL fHeight = m_pChatItem->GetFontHeight();
	FontStyle fontStyle = m_pChatItem->GetFontStyle();
	WCHAR* strFontName = m_pChatItem->GetFontFaceName();
	if(strFontName != NULL && fHeight == 9.0f && fontStyle == FontStyleRegular && _wcsicmp(strFontName, g_defaultFontFaceName) == 0)
	{
		return TRUE;
	}

	return FALSE;
}


